//+------------------------------------------------------------------+
//|                                          Fisher lambic cross.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007 lambic"


//----Section #property
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 Red

double FisherCurrent,FisherPrevious,FisherPrevious1;
double TrendC,TrendP,TrendP1;
extern double FisherPeriod=80;
double TimeFrame=0;
extern int ma1p =9,ma2p=45; 

extern string help1 = "0:cross 0 - 1:MAslow - 2:MAfast";
extern int choix = 1;
double FishOpenLevel=1000;

extern int barToCheck = 0;
extern string help2 = "fleche 0:no -1:point -2:fleche ou chiffre";
extern int fleche = 162;
extern int width = 3;
int mode;



int    i,j,limit,counted_bars, nShift;
extern bool SpeakToMe= false;
extern bool BellAlert= true;







//---- Buffers
double ExtMapBuffer1[];    //Fleche Haut
double ExtMapBuffer2[];    //Fleche Bas

int firstup=0;
int alertTag;
string symbolTxt;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
   {
//---- indicators
//---- Styles et couleur des Fleches      
      SetIndexStyle(0, DRAW_ARROW, 0,width);    // Fleche vers le haut
      SetIndexBuffer(0, ExtMapBuffer1);
      SetIndexStyle(1, DRAW_ARROW, 0, width);    // Fleche vers le bas
      SetIndexBuffer(1, ExtMapBuffer2);
      
      
     if (fleche == 1){
      SetIndexArrow(1, 234);
      SetIndexArrow(0, 233);}
     if (fleche == 2){
      SetIndexArrow(1, 108);
      SetIndexArrow(0, 108);}
     if (fleche != 0||fleche != 1||fleche != 2){
      SetIndexArrow(1, fleche);
      SetIndexArrow(0, fleche);} 
      
//----       
      switch(Period())
         {
            case     1: nShift = 1;      break;
            case     5: nShift = 3;      break;
            case    15: nShift = 5;      break;
            case    30: nShift = 10;     break;
            case    60: nShift = 10;     break;
            case   240: nShift = 30;     break;
            case  1440: nShift = 50;     break;
            case 10080: nShift = 50;    break;
            case 43200: nShift = 50;    break;
         }
             
//----
      return(0);
   }

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
   {

    

//----
      return(0);
   }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
   {


   
if (Symbol()=="EURUSD") { symbolTxt = "Euro Dollar"; }
if (Symbol()=="EURJPY") { symbolTxt = "Euro Yen "; }
if (Symbol()=="EURAUD") { symbolTxt = "Euro Aussie "; }
if (Symbol()=="EURCAD") { symbolTxt = "Euro Canadian"; }
if (Symbol()=="EURCHF") { symbolTxt = "Euro Swiss"; }
if (Symbol()=="GBPUSD") { symbolTxt = "Cable Dollar"; }
if (Symbol()=="GBPJPY") { symbolTxt = "Cable Yen "; }
if (Symbol()=="GBPCHF") { symbolTxt = "Cable Swiss"; }
if (Symbol()=="AUDUSD") { symbolTxt = "Aussie"; }
if (Symbol()=="USDCHF") { symbolTxt = "Swiss Dollar"; }
if (Symbol()=="USDCAD") { symbolTxt = "Canada"; }
if (Symbol()=="USDJPY") { symbolTxt = "Yen Dollar"; } 
if (Symbol()=="CHFJPY") { symbolTxt = "Swiss Yen "; }
if (Symbol()=="GOLD")   { symbolTxt = "Gold"; }

      counted_bars=IndicatorCounted();
//----
      if(counted_bars<0) 
         return(-1);
      if(counted_bars>0) 
         counted_bars--;
      limit=Bars-counted_bars;
//----       
      for(int i=0; i<limit; i++)
         {
           
            FisherCurrent = iCustom(Symbol(),TimeFrame,"Fisher lambic",FisherPeriod,0,ma1p,ma2p,2,i);
            FisherPrevious= iCustom(Symbol(),TimeFrame,"Fisher lambic",FisherPeriod,0,ma1p,ma2p,2,i+barToCheck+1);
            FisherPrevious1=iCustom(Symbol(),TimeFrame,"Fisher lambic",FisherPeriod,0,ma1p,ma2p,2,i+barToCheck+2);
            
            if (choix==1)
            {
            TrendC=iCustom(Symbol(),TimeFrame,"Fisher lambic",FisherPeriod,0,ma1p,ma2p,4,i);
            TrendP=iCustom(Symbol(),TimeFrame,"Fisher lambic",FisherPeriod,0,ma1p,ma2p,4,i+barToCheck+1);
            TrendP1=iCustom(Symbol(),TimeFrame,"Fisher lambic",FisherPeriod,0,ma1p,ma2p,4,i+barToCheck+2);
            }
            if (choix==0)
            {
            TrendC=0;
            TrendP=0;
            TrendP1=0;
            }
             if (choix==2)
            { 
            TrendC=iCustom(Symbol(),TimeFrame,"Fisher lambic",FisherPeriod,0,ma1p,ma2p,3,i);
            TrendP=iCustom(Symbol(),TimeFrame,"Fisher lambic",FisherPeriod,0,ma1p,ma2p,3,i+barToCheck+1);
            TrendP1=iCustom(Symbol(),TimeFrame,"Fisher lambic",FisherPeriod,0,ma1p,ma2p,3,i+barToCheck+2);
            }
            Comment("Fisher=",(FisherPeriod));
   
//            
            
//---- Dessin des fleches, future entr en trade
//---- BUY
             ExtMapBuffer1[i] = 0;ExtMapBuffer2[i] = 0;
           
             if((FisherCurrent>=TrendC)&&(FisherPrevious<TrendP))//&&(FisherPrevious1<TrendP1))//&&(FisherCurrent>FishOpenLevel*Point))
             {
            
            ExtMapBuffer1[i] = Low[i] -nShift*Point;
            //ExtMapBuffer7[i] = 1;
            
             
             if ( BellAlert && firstup && !i && alertTag != Time[0])
               {
                     Alert( Symbol(), " ", Period(), " FISH MA BUY" );
                     alertTag = Time[0];
               }
               
            if ( SpeakToMe && firstup && !i && alertTag != Time[0])
               {   
                     Comment("Check for Buy. "+symbolTxt);
                     alertTag = Time[0];
               }
          
            }
           
//---- SELL 
             
                
             if((FisherCurrent<=TrendC)&&(FisherPrevious>TrendP))
            {
             ExtMapBuffer2[i] = High[i] + nShift*Point;
           if ( BellAlert && firstup && !i && alertTag != Time[0])
            {
                   Alert (Symbol()," ",Period()," FISH MA SELL");
                   alertTag = Time[0];
            }
     if ( SpeakToMe && firstup && !i && alertTag != Time[0])
            {
                  Comment("Check for Sell. "+symbolTxt);
                  alertTag = Time[0];
            }
           }
  
   firstup = firstup + 1;
            }
//----
      return(0);
   }
//+------------------------------------------------------------------+